{{                              
Master code, to send the data readed from SD, to the slaves
}}
'
' Pins   P16..23 Data Bus                                                           OUTS
' Pin    P24    ATT      Attention      (I'll send a dir to the slaves)             OUT
' Pin    P25    DAV      Data available (Data available for some slave)             OUT
' Pin    P26    DRD      Data readed    (Some slave answer, that got the data sent) INPUT

con
     ATT  = 24
     DAV  = 25
     DRD  = 26

obj
   term: "tv_text"


var
'
   long cog
   long Stack[40]       ' Putting 20 here my card brokes his FAT file system.
   long temp1
   long Bdir            ' Buffer address
   long Ddir            ' Data address
   long Snum            ' Slave number
   long BigBuffer_pos   ' Actual position into the Big Buffer, where I'm reading data to send to the slaves.
   long byte_sent       ' Quantity of bytes sent to some slave.
   
PUB Start(Flag_adr,BBdir) : Success  

   Stop
   Success :=  (Cog := cognew(Send2Slave(Flag_adr,BBdir), @Stack) + 1) ' El dato contenido en direc tiene que ser = 0  para que no mande data a los TLC

PUB Stop
{{Stop toggling process, if any.}}

  if Cog
    cogstop(Cog~ - 1)

PUB Send2Slave(Flag_adr,BBdir) | w                          ' Flag_adr dir of the buffers flags.

   outa[16..23]~
   outa[24]~
   outa[25]~

   dira[16..23]~~
   dira[24]~~ 
   dira[25]~~ 
   dira[26]~
    
   term.start(12)
      byte_sent := 0
      BigBuffer_pos := 0
      Snum := 0                                         ' Slave number.
      Ddir := 0                                         ' The address, from where I take data to send to the slaves
      w := 0

      '-----------------------------------------------------------------------------------------------------------------------------
      ' This piece of code, check for sub-buffers filled, and if true, jump to send data to slaves.
      repeat
        temp1 := byte[Flag_adr + w]                     ' Check for some flag ready, indicating I can send from his associate sub-buffer. 
        If temp1 
          Bdir := w++ 
          SendBuf(Bdir,Flag_adr,BBdir)
        if w == 4
           w := 0
      '-----------------------------------------------------------------------------------------------------------------------------
                        
PUB SendBuf(bufdir,buf,BigBuf) | SubBuffer_pos
' bufdir := Sub buffer number (0, 1, 2, 3) ready to read.
' buf    := Start address of the 1st Flag.
' BigBuf := Start address of the big buffer

   SubBuffer_pos := 0

   repeat while SubBuffer_pos =< 2047

    ifnot byte_sent                     ' If I'm just beggining with a packet of 1152 bytes now, First I select the correct slave.
       If Snum == 17
        Snum := 0
      GetSlave
     
    repeat while SubBuffer_pos =< 2047 and byte_sent =< 1151    ' This loop to send 1152 bytes or less of data to the slave selected. 
      outa[16..23] := BigBuf[BigBuffer_pos++]
      outa[DAV]~~                       ' Activate the Data Ready pin
      waitpeq(0,|<DRD,0)                ' wait for DRD pin to go low
      outa[DAV]~                        ' Deactivate the Data Ready pin (Data is yet at the slave)
      byte_sent++
      SubBuffer_pos++
      
    if byte_sent == 1152                ' If finished to send the data to the actual selected slave, I let get the next one.
       byte_sent := 0
    
   Case bufdir
      0: byte[buf] := 0
         term.out($0D)
         term.dec(bufdir)
      1: byte[buf+1] := 0
         term.out($0D)
         term.dec(bufdir)
      2: byte[buf+2] := 0
         term.out($0D)
         term.dec(bufdir)
      3: byte[buf+3] := 0
         term.out($0D)
         term.dec(bufdir)

return

PUB GetSlave                   ' Send to the slaves a byte for recognize one of them.

         outa[16..23] := Snum
         outa[ATT]~~
         waitpeq(0,|<DRD,0)    ' wait for DRD pin to go low
         outa[ATT]~            
         Snum++                ' Increment for the next slave 
